import * as ec2 from '@aws-cdk/aws-ec2';
import * as iam from '@aws-cdk/aws-iam';
import * as cdk from '@aws-cdk/core';
/**
 * @stability stable
 */
export interface IInstanceServiceProps {
    /**
     * The Amazon Machine Image (AMI) to launch the target instance with.
     *
     * @stability stable
     */
    ami: ec2.IMachineImage;
    /**
     * Whether or not to enable logging to Cloudwatch Logs.
     *
     * @default true
     * @stability stable
     */
    enableCloudwatchLogs?: boolean;
}
/**
 * @stability stable
 */
export interface IManagedLoggingPolicyProps {
    /**
     * The OS of the instance this policy is for.
     *
     * @stability stable
     */
    os: string;
}
export declare function ec2ImageToOsString(stack: cdk.Construct, image: ec2.IMachineImage): string;
/**
 * @stability stable
 */
export declare class ManagedLoggingPolicy extends cdk.Construct {
    /**
     * @stability stable
     */
    readonly policy: iam.ManagedPolicy;
    /**
     * @stability stable
     */
    constructor(scope: cdk.Construct, id: string, props: IManagedLoggingPolicyProps);
}
/**
 * @stability stable
 */
export declare class InstanceService extends cdk.Construct {
    /**
     * @stability stable
     */
    constructor(scope: cdk.Construct, id: string, props: IInstanceServiceProps);
}
